  var countries = null;
  var world = {
    auto: new Array(),
    w: new Array(),
    a: new Array(),
    f: new Array(),
    e: new Array(),
    m: new Array(),
    s: new Array()
  }  
  var hash = null;
  
  function mapSetup() {
    updateMap("w", "");
    loadCountries();
    mapSelected();
    /*
    $("Content").style.display = "block";
    $("Loading").style.display = "none";
    */
  }
  
  function updateMap(region, country) {
    var area = "world";
    var index = 0;
    while (index < region.length) {
      switch(region[index++]) {
        case "a": area = "asia"; 
                  break;
        case "f": area = "africa"; 
                  break;
        case "e": area = "europe"; 
                  break;
        case "m": area = "middle_east"; 
                  break;
        case "s": area = "south_america"; 
                  break;
        case "u": area = "usa"; 
                  break;
        case "w": area = "world"; 
                  break;
        default: continue;          
      }
      break;            
    }
    var chart = "http://chart.apis.google.com/chart?" 
                + "chs=" + "440x208"
                + "&chd=s:_&cht=t"
                + "&chtm=" + area 
                + "&chco=ffffff,ff0000,ff0000"
                + "&chld=" + country
                + "&chd=s:Af9"
                + "&chf=bg,s,404040"
    $("MapImage").src = chart;            
  }
  
  function countrySelected() {
    var value = $("CountrySelect").value;
    var country = hash[value];
    //gSelectButton.textElement.innerHTML = country.title;
    var area = $("MapSelect").value;
    if (area == "auto") {
      area = country.area;
    }
    updateMap(area, value);
    if (country) {
      $("MapTitle").innerHTML = country.title;
    }
  } 
  
  function selectRandom() {
    var index = Math.floor(Math.random() * countries.length);
    $("CountrySelect").selectedIndex = index;
    countrySelected();
  }
  
  function mapSelected() {
    countries = world[$("MapSelect").value];
    fillCountrySelect();
    selectRandom();
  }

  function loadCountries() {
    var request = new XMLHttpRequest();
    request.open("GET", "countries.csv", false);
    request.send(null);
    if (request.status == 200 || request.status == 0) {
      var lines = request.responseText.split("\n");
      hash = new Object();
      for (var i = 0; i < lines.length; i++) {
      	var line = lines[i];
      	var start = 0;
      	if (line[0] == '"') {
      	  start = line.indexOf('"', 1);
      	}
      	var index = line.indexOf(",", start);
      	if (index > 0) {
      	  var country = new Object();
      	  country.title = modifyTitle(line.substring(0, index));
      	  country.code = line.substring(index + 1, index + 3);
      	  country.area = "w";
      	  if (lines.length > index + 3) {
      	    country.area = line.substring(index + 4) + country.area;
      	  }
      	  world.auto.push(country);
      	  world.w.push(country);
      	  if (world[country.area[0]]) {
      	    world[country.area[0]].push(country);
      	  }
      	  hash[country.code] = country;
      	}
      }
    }
  }
  
  function fillCountrySelect() {
    $("CountrySelect").innerHTML = "";
    for (var i = 0; i < countries.length; i++) {
    	var option = document.createElement("option");
    	option.value = countries[i].code;
    	option.innerHTML = countries[i].title;
    	$("CountrySelect").appendChild(option);
    }    
  }
  
  function modifyTitle(title) {
    title = title.replace(/\"/g, "");
    var result = "";
    var words = title.toLowerCase().split(' ');
    for (var i = 0; i < words.length; i++) {
    	var word = words[i];
    	if (word.length > 0) {
    	  word = word[0].toUpperCase() + word.substring(1);
    	  result += word + " ";
    	}  
    }
    return result;
  }
  
  function $(id) {
    return document.getElementById(id);
  } 